#include "scripts.h"
#include <QDebug>
#include "../common/sources/Map.h"

CScripts    scripts;

CScripts::CScripts()
{

}

//--------------------------------------------------------------------------
void CScripts::execute(std::string fileName)
{
    if (fileName.empty() == false)
    {
        static char cFileName[256];
        static char line[256];

        sprintf(cFileName, "scripts/%s", fileName.c_str());
        FILE*   f = fopen(cFileName, "rt");

        while (fgets(line, 256, f) != NULL)
        {
            // split the line into words
            static std::vector<std::string>    words;
            words.clear();
            char* ptr;
            ptr = strtok(line," \t\r\n");

            while (ptr != NULL)
            {
                words.push_back(ptr);
                ptr = strtok(NULL, " \t\r\n");
            }

            // execute the line
            executeLine(words);
        }
        fclose (f);
    }
}

//--------------------------------------------------------------------------
void CScripts::executeLine(std::vector<std::string>& words)
{
    if (words[0] == "Target")
        executeTarget(words);
    else if (words[0] == "SetBool")
        executeSetBool(words);
}

//--------------------------------------------------------------------------
void CScripts::executeTarget(std::vector<std::string>& words)
{
    int x = std::stoi(words[2]);
    int y = std::stoi(words[3]);
    CTile*  tile = map.getTile(CVec2(x, y));

    if (words[1] == "Tile")
    {
        mTargetType = eTargetType_Tile;
        mTarget = (void*)tile;
    }
    else
    {
        mTargetType = eTargetType_Wall;
        // mTarget = ...
    }
}

//--------------------------------------------------------------------------
void CScripts::executeSetBool(std::vector<std::string>& words)
{
    QString param = QString::fromStdString(words[1]);
    bool    value = (words[2] == "true" ? true : false);

    if (mTargetType == eTargetType_Tile)
        ((CTile*)mTarget)->setBoolParam(param, value);
    else
        ((CWall*)mTarget)->setBoolParam(param, value);
}
